int red1 = 10;
int yellow1 = 9;
int green1 = 8;

int red2 = 5;
int yellow2 = 4;
int green2 = 3;

int button = 2;
bool firstLoopAfterPress = true;
volatile bool buttonPressed = false;

uint8_t sensor = A0;
volatile int timeBeforeColorChange = 5000;
int timeBetweenStates = 7000;

enum LightState {
  GREEN_RED,
  YELLOW_REDYELLOW,
  RED_GREEN,
  REDYELLOW_YELLOW
};

LightState currentLightState = GREEN_RED;
unsigned long startStateTime = 0;

volatile unsigned long seconds = 0;


void buttonInterrupt() {
  buttonPressed = true;
}

ISR(TIMER1_COMPA_vect) {
  seconds += 1000;
}

void configureTimer() {
  TCCR1A = 0;
  TCCR1B = 0;
  TCNT1 = 0;
  OCR1A = 15264;
  TCCR1B |= (1 << WGM12);
  TCCR1B |= (1 << CS10) | (1 << CS12);
  TIMSK1 |= (1 << OCIE1A);
}

void changeLights() {
  if (seconds - startStateTime >= timeBeforeColorChange && currentLightState == GREEN_RED) {
      digitalWrite(green1, LOW);
      digitalWrite(yellow1, HIGH);
      digitalWrite(yellow2, HIGH);
      startStateTime = seconds;
      currentLightState = YELLOW_REDYELLOW;
  } else if (seconds - startStateTime >= timeBetweenStates && currentLightState == YELLOW_REDYELLOW) {
      digitalWrite(yellow1, LOW);
      digitalWrite(red1, HIGH);
      digitalWrite(yellow2, LOW);
      digitalWrite(red2, LOW);
      digitalWrite(green2, HIGH);
      startStateTime = seconds;
      currentLightState = RED_GREEN;
  } else if (seconds - startStateTime >= timeBetweenStates && currentLightState == RED_GREEN) {
      digitalWrite(yellow1, HIGH);
      digitalWrite(yellow2, HIGH);
      digitalWrite(green2, LOW);
      startStateTime = seconds;
      currentLightState = REDYELLOW_YELLOW;
  } else if (seconds - startStateTime >= timeBetweenStates && currentLightState == REDYELLOW_YELLOW) {
      digitalWrite(green1, HIGH);
      digitalWrite(yellow1, LOW);
      digitalWrite(red1, LOW);
      digitalWrite(yellow2, LOW);
      digitalWrite(red2, HIGH);
      currentLightState = GREEN_RED;
      buttonPressed = false;
      firstLoopAfterPress = true;
  }
}

void setup() {
  Serial.begin(9600);
  pinMode(red1, OUTPUT);
  pinMode(yellow1, OUTPUT);
  pinMode(green1, OUTPUT);

  pinMode(red2, OUTPUT);
  pinMode(yellow2, OUTPUT);
  pinMode(green2, OUTPUT);

  pinMode(button, INPUT_PULLUP);
  attachInterrupt(0, buttonInterrupt, FALLING);
  digitalWrite(green1, HIGH);
  digitalWrite(red2, HIGH);
 
  configureTimer();
}

void loop() {
  int sensorValue = analogRead(sensor);
  float sensorVoltage = sensorValue * (5.0 / 1023.0);
  if (sensorVoltage <= 1.5) {
    timeBeforeColorChange = 2000;
    Serial.println("Este frig afara!");
  } else {
    timeBeforeColorChange = 5000;
  }

  if (buttonPressed) {
    if (firstLoopAfterPress) {
      startStateTime = seconds;
      firstLoopAfterPress = false;
    }
    changeLights();
  }
}
